- name: Secondary database - Stop puma/sidekiq for single node
  block:
    - name: Secondary Database - Run gitlab-ctl stop puma
      command: gitlab-ctl stop puma

    - name: Secondary Database - Run gitlab-ctl stop sidekiq
      command: gitlab-ctl stop sidekiq
  when: ('gitlab_rails' in group_names and geo_secondary_site_group_name + '_postgres_primary' not in groups)

- name: Copy psql certificate
  copy:
    src: "{{ local_tmp }}server.crt"
    dest: /tmp/
    mode: 0400

- name: Install certificate
  command: |
    install -D \
            -o gitlab-psql \
            -g gitlab-psql \
            -m 0400 \
            -T /tmp/server.crt ~gitlab-psql/.postgresql/root.crt

- name: Secondary database - Add new config
  template:
    src: templates/secondary-database.rb.j2
    dest: /etc/gitlab/gitlab.geo.secondary-database.rb

- name: Secondary database - Remove existing cluster information for Patroni
  import_tasks: secondary-database-patroni-workaround.yml
  when:
    - postgres_replication_manager == 'patroni'

- name: Secondary Database - Run gitlab-ctl reconfigure
  command: gitlab-ctl reconfigure

- name: Secondary Database - Restart Postgres
  command: gitlab-ctl restart

# Not required when using Patroni as Patroni handles this automatically
- name: Secondary Database - Replicate geo database
  expect:
    command: |
      gitlab-ctl replicate-geo-database \
        --slot-name={{ inventory_hostname | regex_replace("-", "_") }} \
        --host={{ geo_primary_site_postgres_int_ip }} \
        --force
    responses:
      (.*)Confirmation: "replicate"
      (.*)Enter the password for gitlab_replicator@(.*): "{{ postgres_password }}"
    timeout: 300
  when:
    - postgres_replication_manager != 'patroni'
    - ('postgres_primary' in group_names or ('gitlab_rails' in group_names and geo_secondary_site_group_name + '_postgres_primary' not in groups))
